<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\master_worker;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\master_worker\EngineerSettlement;
use app\common\lists\ListsSearchInterface;


/**
 * EngineerSettlement列表
 * Class EngineerSettlementLists
 * @package app\adminapi\lists
 */
class EngineerSettlementLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/11/15 17:21
     */
    public function setSearch(): array
    {
        return [
            '=' => ['batch_number','master_worker_id', 'worker_number', 'engineer_name', 'original_balance', 'total_settlement_amount', 'deduction_amount', 'final_settlement_amount',  'settlement_details_remarks'],

        ];
    }

    public function queryWhere()
    {
        $where = [];
        if(isset($this->params['settlement_time']) && $this->params['settlement_time']){
            $where[] = ['settlement_time','=',date('Y-m-d H:i:s',strtotime($this->params['settlement_time']))];
        }
        if(isset($this->params['create_time']) && $this->params['create_time']){
            $startDateTime = strtotime($this->params['create_time']);
            $endDateTime = strtotime('+1 day', $startDateTime)-1;
            $where[] = ['create_time','BETWEEN',[$startDateTime,$endDateTime]];
        }
        return $where;
    }
    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/11/15 17:21
     */
    public function lists(): array
    {
        return EngineerSettlement::where('is_export',2)->where($this->queryWhere())->where($this->searchWhere)
            ->field(['id', 'master_worker_id', 'worker_number', 'engineer_name', 'original_balance', 'total_settlement_amount', 'deduction_amount','deduction_describe', 'final_settlement_amount', 'settlement_time', 'settlement_details_remarks','batch_number'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/11/15 17:21
     */
    public function count(): int
    {
        return EngineerSettlement::where($this->searchWhere)->where($this->queryWhere())->count();
    }

}